<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <!-- <el-form-item label="父级编号" prop="parentId">
        <el-input
          v-model="queryParams.parentId"
          placeholder="请输入父级编号"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="业态类型编号" prop="businessId">
        <el-input
          v-model="queryParams.businessId"
          placeholder="请输入业态类型编号"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="业态类型名称" prop="businessName">
        <el-input
          v-model="queryParams.businessName"
          placeholder="请输入业态类型名称"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item> -->
      <el-form-item label="状态" prop="businessStatus">
        <el-select v-model="queryParams.businessStatus" placeholder="请选择状态" clearable>
          <el-option
            v-for="dict in dict.type.monitorStatus"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <!-- <el-form-item label="权限标识" prop="userId">
        <el-input
          v-model="queryParams.userId"
          placeholder="请输入权限标识"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="权限标识" prop="deptId">
        <el-input
          v-model="queryParams.deptId"
          placeholder="请输入权限标识"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item> -->
      <el-form-item>
	    <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['base:businessType:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="info"
          plain
          icon="el-icon-sort"
          size="mini"
          @click="toggleExpandAll"
        >展开/折叠</el-button>
      </el-col>
      <el-col :span="1.5">
        共{{list.length}}条
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table
      v-if="refreshTable"
      v-loading="loading"
      :data="businessTypeList"
      row-key="objid"
      :default-expand-all="isExpandAll"
      :tree-props="{children: 'children', hasChildren: 'hasChildren'}"
    >
      <!-- <el-table-column label="父级编号" prop="parentId" /> -->
      <!-- <el-table-column label="业态类型编号" align="center" prop="businessId" /> -->
      <el-table-column label="业态类型名称" align="center" prop="businessName" />
      <el-table-column label="状态" align="center" prop="businessStatus">
        <template slot-scope="scope">
          <dict-tag :options="dict.type.monitorStatus" :value="scope.row.businessStatus"/>
        </template>
      </el-table-column>
      <!-- <el-table-column label="权限标识" align="center" prop="userId" />
      <el-table-column label="权限标识" align="center" prop="deptId" /> -->
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['base:businessType:edit']"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-plus"
            @click="handleAdd(scope.row)"
            v-hasPermi="['base:businessType:add']"
          >新增</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['base:businessType:remove']"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <!-- 添加或修改业态类型管理对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="auto">
        <el-form-item label="父级编号" prop="parentId">
          <treeselect v-model="form.parentId" :options="businessTypeOptions" :normalizer="normalizer" placeholder="请选择父级编号" />
        </el-form-item>
        <!-- <el-form-item label="业态类型编号" prop="businessId">
          <el-input v-model="form.businessId" placeholder="请输入业态类型编号" />
        </el-form-item> -->
        <el-form-item label="业态类型名称" prop="businessName" label-width="100px">
          <el-input v-model="form.businessName" placeholder="请输入业态类型名称" />
        </el-form-item>
        <el-form-item label="状态" prop="businessStatus">
          <el-radio-group v-model="form.businessStatus">
            <el-radio
              v-for="dict in dict.type.monitorStatus"
              :key="dict.value"
              :label="parseInt(dict.value)"
            >{{dict.label}}</el-radio>
          </el-radio-group>
        </el-form-item>
        <!-- <el-form-item label="权限标识" prop="userId">
          <el-input v-model="form.userId" placeholder="请输入权限标识" />
        </el-form-item>
        <el-form-item label="权限标识" prop="deptId">
          <el-input v-model="form.deptId" placeholder="请输入权限标识" />
        </el-form-item> -->
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listBusinessType, getBusinessType, delBusinessType, addBusinessType, updateBusinessType } from "@/api/ems/base/businessType";
import Treeselect from "@riophae/vue-treeselect";
import "@riophae/vue-treeselect/dist/vue-treeselect.css";

export default {
  name: "BusinessType",
  dicts: ['monitorStatus'],
  components: {
    Treeselect
  },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 返回条数
      list: null,
      // 显示搜索条件
      showSearch: true,
      // 业态类型管理表格数据
      businessTypeList: [],
      // 业态类型管理树选项
      businessTypeOptions: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 是否展开，默认全部展开
      isExpandAll: true,
      // 重新渲染表格状态
      refreshTable: true,
      // 查询参数
      queryParams: {
        parentId: null,
        businessId: null,
        businessName: null,
        businessStatus: null,
        userId: null,
        deptId: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
      }
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询业态类型管理列表 */
    getList() {
      this.loading = true;
      listBusinessType(this.queryParams).then(response => {
        this.list = response.data;
        this.businessTypeList = this.handleTree(response.data, "objid", "parentId");
        this.loading = false;
      });
    },
    /** 转换业态类型管理数据结构 */
    normalizer(node) {
      if (node.children && !node.children.length) {
        delete node.children;
      }
      return {
        id: node.objid,
        label: node.businessName,
        children: node.children
      };
    },
	/** 查询业态类型管理下拉树结构 */
    getTreeselect() {
      listBusinessType().then(response => {
        this.businessTypeOptions = [];
        const data = { objid: 0, businessName: '顶级节点', children: [] };
        data.children = this.handleTree(response.data, "objid", "parentId");
        this.businessTypeOptions.push(data);
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        objid: null,
        parentId: null,
        businessId: null,
        businessName: null,
        businessStatus: null,
        userId: null,
        deptId: null,
        createBy: null,
        createTime: null,
        updateBy: null,
        updateTime: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    /** 新增按钮操作 */
    handleAdd(row) {
      this.reset();
      this.getTreeselect();
      if (row != null && row.objid) {
        this.form.parentId = row.objid;
      } else {
        this.form.parentId = 0;
      }
      this.open = true;
      this.title = "添加业态类型管理";
    },
    /** 展开/折叠操作 */
    toggleExpandAll() {
      this.refreshTable = false;
      this.isExpandAll = !this.isExpandAll;
      this.$nextTick(() => {
        this.refreshTable = true;
      });
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      this.getTreeselect();
      if (row != null) {
        this.form.parentId = row.objid;
      }
      getBusinessType(row.objid).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改业态类型管理";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.objid != null) {
            updateBusinessType(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addBusinessType(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      this.$modal.confirm('是否确认删除业态类型管理编号为"' + row.objid + '"的数据项？').then(function() {
        return delBusinessType(row.objid);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {});
    }
  }
};
</script>
